
#ifndef ATEXTBROWSER_H
#define ATEXTBROWSER_H

#include <qtextbrowser.h>
#include <defines.h>

/**Just to replace setSource from QTextBrowser.
  *@author eugen
  */

class AETHERA_API ATextBrowser : public QTextBrowser
{
  Q_OBJECT
   
  public:
   
    ATextBrowser(QWidget *parent=0, const char *name=0);
    virtual ~ATextBrowser();
    
    /** Check if the cursor is on a link.
      * If yes, it set the internal link name and the link href
      * so that you can safely call anchorName() and anchorHref()
      * public methods.
      */
    virtual bool isOnLink(const QPoint &);
    
    /** The anchor name if isOnLink() is true.*/
    QString anchorName() const;
    
    /** The anchor href if isOnLink() is true.*/
    QString anchorHref() const;
  
  public slots:
  
    virtual void setSource(const QString&);
    
  protected:

    virtual void contentsMousePressEvent(QMouseEvent *e);
      
    QString linkName;
    QString linkHref;
};

#endif
