/***************************************************************************
                          mail.h  -  description
                             -------------------
    begin                : Tue Oct 1 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Eugen Constantinescu
    email                : eug@thekompany.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAIL_H
#define MAIL_H

#include <defines.h>

class QPixmap;
class QString;

/**Some general things about mails.
  *@author Eugen C.
  */

class AETHERA_API Mail
{
  public:
  
    enum Attachment { NoAttachment=0,
                      HasAttachment };
    
    enum Priority { Lowest=0,
                    Low,
                    Normal,
                    High,
                    Highest };
    
    enum Status { Default=0,
                  Forwarded,
                  Replyed,
                  ReplyedForwarded };
    
    virtual ~Mail();
    
    static Mail * instance();
    
    /** Attachment to String.*/
    static QString toString(Mail::Attachment);
    /** Attachment to Pixmap.*/
    static QPixmap toPixmap(Mail::Attachment);
    /** String to Attachment.*/
    static Mail::Attachment toAttachment(const QString &);

    /** Priority to String.*/
    static QString toString(Mail::Priority);
    /** Priority to Pixmap.*/
    static QPixmap toPixmap(Mail::Priority);
    /** String to Priority.*/
    static Mail::Priority toPriority(const QString &);

    /** Status to String.*/
    static QString toString(Mail::Status);
    /** Status to Pixmap.*/
    static QPixmap toPixmap(Mail::Status);
    /** String to Status.*/
    static Mail::Status toStatus(const QString &);

  private:
  
    Mail();
    
    static Mail * instance_;
};

#endif
