
#include "vfsmimetype.h"

VFSMimeType::VFSMimeType()
{
}

VFSMimeType::~VFSMimeType()
{
}

QString VFSMimeType::vfs2mime(const QString & vfsType)
{
  if( vfsType.isEmpty() )
    return QString::null;
  
  QString mime;
  char c = vfsType[0].lower().latin1();
  
  switch(c)
  {
    // mail
    case 'm':
      mime = MIME_MAIL;
      break;
    
    // contacts
    case 'c':
      mime = MIME_CONTACTS;
      break;
    
    // notes
    case 'n':
      mime = MIME_NOTES;
      break;
    
    // group
    case 'g':
      mime = MIME_GROUPS;
      break;
    
    // whiteboard
    case 'w':
      mime = MIME_WHITEBOARD;
      break;
    
    // jabber
    case 'j':
      mime = MIME_JABBER;
      break;
    
    // datebook
    case 'd':
      mime = MIME_CALENDAR;
      break;
    
    default:
      mime = MIME_UNKNOWN;
      break;
  }
  
  return mime;
}

