
#include "vfsobjectlistview.h"

/*
---------------------------------------------------------------
VFSObjectListView class
---------------------------------------------------------------
*/

VFSObjectListView::VFSObjectListView(QWidget* parent, const char* name)
  :QListView(parent,name)
{
}


/*
---------------------------------------------------------------
VFSObjectListViewItem class
---------------------------------------------------------------
*/

class VFSObjectListViewItem::Private
{
  public:
  
    Private(VFSObjectListViewItem *);
    ~Private();
    
    void init();

    VFSObjectListView* listView;
    QColor alternativeBackground;
    bool hasKnownColor;
    bool rankNumber;
  
  private:
  
    VFSObjectListViewItem * parent_;
};

VFSObjectListViewItem::Private::Private(VFSObjectListViewItem * parent)
  : listView(0L),
    alternativeBackground(230,230,240),
    hasKnownColor(false),
    rankNumber(true),
    parent_(parent)
{
}
    
VFSObjectListViewItem::Private::~Private()
{
}
    
VFSObjectListViewItem::VFSObjectListViewItem(VFSObjectListView* parent, const char* name)
  : QListViewItem( parent, name )
{
  d = new Private(this);
  
  d->listView = parent;
}


VFSObjectListViewItem::~VFSObjectListViewItem()
{
  if( d )
  {
    delete d;
    d = 0L;
  }
}

void VFSObjectListViewItem::paintCell(QPainter *p,const QColorGroup &cg,int column,int width,int alignment)
{
  // TODO
  // This has to be changed with a much better algorithm.
  //
  
  QColorGroup _cg=cg;
  unsigned parity = 0;
  QListViewItemIterator it( d->listView );

  while( (it.current()!=0) )
  {
    if( it.current() == this )
      break;
    ++it;
    ++parity;
  }
  
  if( parity%2 )
    _cg.setBrush( QColorGroup::Base, QBrush(d->alternativeBackground) );
  
  QListViewItem::paintCell( p, _cg, column, width, alignment );
}


bool VFSObjectListViewItem::isAlternante()
{
  // TODO
  
  return true;
}

