/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
                kompluginmanager.cpp  -  the plug in manager
                             -------------------
    begin                : Wed Aug 29 14:02:00 EET 2001
    copyright            : (C) 2001 by theKompany.com (www.thekompany.com>
    author               : Eugen Constantinescu
    email                : eug@thekompany.com
 ***************************************************************************/

#include "kompluginmanager.h"
#include <qsettings.h>
#include <komaetheratools.h>

#include <defines.h>
#include <settings.h>
#include <dirs.h>

KomPlugInManager::KomPlugInManager()
{
}

KomPlugInManager::~KomPlugInManager()
{
}

void KomPlugInManager::loadPlugins()
{
//  qDebug("KomAetheraMan::loadPlugins() %s", "start");

  QString pluginDir( Dirs::locateDir("plugins") );

  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    LibraryLocator* locator = dynamic_cast<LibraryLocator*>(trader->registeredComponent("/kore/service/locator").instance());
    if( locator )
    {
      QString userPluginDir = Settings::instance()->readEntry("/Aethera/PlugInManager/PlugInDirectory","");
      QStringList plugIns = Settings::instance()->readListEntry("/Aethera/PlugInManager/LoadedPlugins", ',');
      if( plugIns.isEmpty() )
        plugIns = Settings::instance()->readListEntry("/Aethera/PlugInManager/PlugIns", ',');
      
      // I will use names instead of scanning the whole directory for 
      // keeping the right order in loading the plug ins.
      // TODO This has to be changed.
      for(QStringList::Iterator itPlugIn=plugIns.begin(); itPlugIn!=plugIns.end(); ++itPlugIn)
      {
        qDebug("Trying to load %s", (*itPlugIn).latin1());
        locator->scanLibrary((*itPlugIn).latin1(), pluginDir.latin1(), LibraryLoader::GLOBAL );
        locator->scanLibrary((*itPlugIn).latin1(), userPluginDir.latin1(), LibraryLoader::GLOBAL );
      }
    }
  }
    
//  qDebug("KomAetheraMan::loadPlugins() %s","end");
}

void KomPlugInManager::freePlugins()
{
}




