
#include "homeconfighandler.h"

#include <externalbrowser.h>
#include <icaodialog.h>

#include <qurl.h>

HomeConfigHandler::HomeConfigHandler(HomeConfigService * parent)
  : QObject(),
    parent_(parent)
{
}

HomeConfigHandler::~HomeConfigHandler()
{
}

void HomeConfigHandler::launchUrl(const QString & text)
{
  QUrl url(text);
  
  ExternalBrowser::launchUrl(url, this);
}

void HomeConfigHandler::slotICAO(const QString &)
{
  ICAODialog icao;
  
  int iRet = icao.exec();
  
  if( QDialog::Accepted == iRet &&
      icao.isSelected() )
  {
    parent_->setICAO( icao.selected() );
  }
}
