/***************************************************************************
                      reportviewer.cpp  -  description
                             -------------------
    begin                : Thu Jan 30 2003
    copyright            : (C) 2003 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/


#include "reportviewer.h"

#include <filedownloader.h>
#include <externalbrowser.h>

#include <qtimer.h>
#include <qfile.h>

ReportViewer::ReportViewer(QObject *parent, const char *name )
  : QObject(parent, name),
    fileDownload(0L),
    refresh(false)
{
  fileDownload = new FileDownloader(this);
  
  connect(fileDownload, SIGNAL(finished(const FileDownloader::Result&, const QString&, const QString&)),
          this, SLOT(slotDataReady(const FileDownloader::Result&, const QString&, const QString&)));
}

ReportViewer::~ReportViewer()
{
}

void ReportViewer::slotUpdate()
{
  qDebug("ReportViewer::slotUpdate()");
  
  refresh = true;
}

void ReportViewer::startTimer(int msec, bool sshot)
{
  timer.start(msec, sshot);
}

void ReportViewer::startTimer()
{
  // by default, 30 min
  timer.start(30 * 60 * 1000, false);
}

void ReportViewer::stopTimer()
{
  timer.stop();
}

bool ReportViewer::isActive()
{
  return timer.isActive();
}

void ReportViewer::slotDataReady( const FileDownloader::Result & result,
                                  const QString & packageUrl,
                                  const QString & savePath)
{
//  qDebug("ReportViewer::slotDataReady");
  
  if( result.type == FileDownloader::Result::Success )
  {
    currentURL = packageUrl;
    
    QFile dataFile(savePath);
    parseData(&dataFile);
      
    show();
  }
  else
  {
    qDebug("ReportViewer error: %s", result.description.latin1());
    
    return;
  }
      
  nextURL();
}

void ReportViewer::slotOpenLink(const QString & url)
{
  QUrl link(url);
  
  ExternalBrowser::launchUrl(link, this);
}

