/***************************************************************************
                          reportviewer.h  -  description
                             -------------------
    begin                : Thu Jan 30 2003
    copyright            : (C) 2003 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/

#ifndef REPORTVIEWER_H
#define REPORTVIEWER_H

#include <filedownloader.h>

#include <qobject.h>
#include <qtimer.h>
#include <qstringlist.h>

class QWidget;
class QIODevice;

/**It can parse some data for showing a report.
  *@author Eugen C. <eug@thekompany.com>
  */

class HOME_PLUGIN_API ReportViewer : public QObject
{
  Q_OBJECT
  
  public:
  
    ReportViewer(QObject *parent=0, const char *name=0);
    virtual ~ReportViewer();
    
    virtual QWidget * widget(QWidget *parent=0, const char *name=0)=0;
    virtual bool isActive();
    
  public slots:
  
    virtual void slotUpdate();
    virtual void startTimer(int, bool sshot=false);
    virtual void startTimer();
    virtual void stopTimer();
    
  protected slots:
  
    virtual void slotDataReady(const FileDownloader::Result&, const QString&, const QString&);
    virtual void slotOpenLink(const QString &);
    
  protected:
  
    virtual bool parseData(QIODevice * dev)=0;
    virtual bool parseData(const QByteArray&)=0;
    
    virtual void show()=0;
    virtual void clear()=0;
    virtual void hideWidget()=0;
    virtual void showWidget()=0;
    virtual void nextURL()=0;
    
    FileDownloader * fileDownload;
    bool refresh;
    QTimer timer;
    QString group;
    QString fileName;
    QString currentURL;
    QStringList urlList;
};

#endif
