//own includes
#include <vfscontactlist.h>

//komcontactplugin includes
#include <vfscontactlistview.h>
#include <vfscontactpreview.h>

/*
-------------------------------------------------
The widget
-------------------------------------------------
*/
VFSContactList::VFSContactList()
{
}


VFSContactList::~VFSContactList()
{

}


bool VFSContactList::hasCapability(const QString& capa)
{
  if( capa==OBJECT_VIEW    ||
      capa==OBJECT_PREVIEW
    )
    return true;

  return false;
}


VFSObjectListView* VFSContactList::newObjectView(QWidget* parent, const char* name)
{
  return new VFSContactListView(parent,name);
}


VFSObjectPreview* VFSContactList::newObjectPreview(QWidget* parent, const char* name)
{
  return new VFSContactPreview(parent,name);
}


/*
-------------------------------------------------
The widget factory
-------------------------------------------------
*/
kore::Interface* vfscontactlist_factory()
{
  return new VFSContactListFactory();
}


VFSContactListFactory::VFSContactListFactory()
{
  MetaInfo* info = metaInfo();

  info->replaceAll("name","VFSContactListFactory");
  info->replaceAll("class","VFSContactListFactory");
  info->replaceAll("class/fqn","VFSContactListFactory");
  info->replaceAll("factory","vfscontactlist_factory");
  info->replaceAll("description",AETHERA_VFS_CONTACT_LIST_FACTORY_DESC);
  info->replaceAll("service", AETHERA_VFS_CONTACT_LIST_FACTORY);
}


VFSContactListFactory::~VFSContactListFactory()
{
  
}

VFSObjectList*  VFSContactListFactory::newObjectList()
{
  VFSContactList* contactList = new VFSContactList();
  if( contactList )
    return contactList;

  return 0L;
}
