//own includes
#include <vfscontactpreview.h>

//Aethera includes
#include <vfsmodule.h> //vfs service - required t build contacts list
#include <vfolder.h>
#include <vfsmimetype.h>

//Qt includes
#include <qlayout.h>

VFSContactPreview::VFSContactPreview(QWidget* parent, const char* name)
  :VFSObjectPreview(parent, name),
   vfs(0L),
   contactPreview(0L),
   automaticPreviewCheckbox(0L),
   generatePreviewButton(0L)
{
  QHBoxLayout* widgetLayout = new QHBoxLayout( this, 0, 3, "widgetLayout" );

  if(!contactPreview)
    contactPreview = new ContactPreviewWidget( this, "contactPreview" );
  widgetLayout->addWidget( contactPreview );
  
  QVBoxLayout* previewControlLayout = new QVBoxLayout( this, 0, 3, "previewControlLayout" );
  QSpacerItem* topSpace = new QSpacerItem( 100,20 );
  previewControlLayout->addItem( topSpace );
  if(!automaticPreviewCheckbox)
  {
    automaticPreviewCheckbox = new QCheckBox( "Automatic",
                                              this,
                                              "automaticPreviewCheckbox"
                                            );
    automaticPreviewCheckbox->setChecked( true );
    previewControlLayout->addWidget( automaticPreviewCheckbox );
  }

/*
We will add this feature as soon as posible
*/

//  if(!generatePreviewButton)
//  {
//    generatePreviewButton = new QPushButton( "Preview", this, "generatePreviewButton" );
//    previewControlLayout->addWidget( generatePreviewButton );
//  }
  widgetLayout->addLayout( previewControlLayout );
    
  if(!vfs)
  {
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
          vfs = static_cast<VFSModule*>(ref.instance());
    }
  }
  
}


VFSContactPreview::~VFSContactPreview()
{
  delete contactPreview;
  contactPreview=0L;
}

void VFSContactPreview::slotSetObject(const QString& path)
{
  VContactObject* selectedContact=0L;

  if(vfs)
  {
    selectedContact =
      (VContactObject *)( vfs->_fact_ref(path, VFS_CONTACTS_MIMETYPE) );
  }
  
  if( selectedContact )
  {
    bool renderPreview = automaticPreviewCheckbox->isChecked();
    if( renderPreview )
    {
      contactPreview->setContact(selectedContact);
    }
  }
}


void VFSContactPreview::slotToggleVisibility(bool visibility)
{
  if(!visibility)
  {
    hide();
  }
  else
  {
    show();
  }
}
