
#include "composerconfigwidget.h"
#include <fontcolorbutton.h>
#include <qcolorbutton.h>

//qt includes
#include <qfiledialog.h>
#include <qlineedit.h>
#include <qpushbutton.h>

//tkcBase includes
#include <settings.h>
#include <qiconloader.h>


ComposerConfigWidget::ComposerConfigWidget(QWidget* parent, const char* name)
  :ComposerConfigWidgetBase(parent, name)
{
  QObject::connect( (QWidget*)openFileButton,
           SIGNAL( clicked() ),
           SLOT( slotChooseSignature() )
         );

  QIconLoader* iconLoader = QIconLoader::instance();
  openFileButton->setPixmap( iconLoader->loadIcon("signature.xpm") );

  QObject::connect( reinterpret_cast<QWidget*>( htmlFormatButton ),
                    SIGNAL( toggled(bool) ),
                    reinterpret_cast<QWidget*>( colorChooserButton ),
                    SLOT( setEnabled(bool) )
                  );

  QObject::connect( reinterpret_cast<QWidget*>( htmlFormatButton ),
                    SIGNAL( toggled(bool) ),
                    reinterpret_cast<QWidget*>( fontChooserButton ),
                    SLOT( setEnabled(bool) )
                  );
    
}

ComposerConfigWidget::~ComposerConfigWidget()
{
  
}


QString ComposerConfigWidget::slotChooseSignature()
{
    QString path = QFileDialog::getOpenFileName("/home","",this,"Open File");
    if( !path.isEmpty() )
    {
      signatureFilePath = path;
      filePathLine->setText( signatureFilePath );
      return path;
    }
    else
      signatureFilePath = path;

  return QString::null;
}
