/***************************************************************************
                          composerfactory.h  -  description
                             -------------------
    begin                : Wed Sep 25 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Eugen Constantinescu
    email                : eug@thekompany.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COMPOSERFACTORY_H
#define COMPOSERFACTORY_H

#include <komaetheraplugin.h>
#include <qobject.h>

class QMainWindow;

/**The factory for ComposerWindow objects.
  *@author Eugen C.
  */

class MAIL_PLUGIN_API ComposerFactory : public QObject
{
  Q_OBJECT
  
  public:
  
    enum Mode { EditMessage = 0,
                Forward,
                ForwardInline,
                ForwardAsAttachment,
                ForwardQuoted,
                Reply,
                ReplyAll,
                SendObject,
                UsingRecipient };

    virtual ~ComposerFactory();

    static ComposerFactory* instance();
    
    void openComposer();
    void openComposer(const QString & vfsUrl, ComposerFactory::Mode);
    void openComposer(const QStringList & vfsUrlList, ComposerFactory::Mode);

    const QPtrList<QMainWindow> & windows();
    
    void clear();

  public slots:

    virtual void slotCloseWindow(QMainWindow*);
  
  private:
  
    ComposerFactory();
    
    static ComposerFactory * instance_;
    
    class Private;
    Private * d;
};

#endif
