/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
        mailuipartprivate.cpp  -  the QT handler from the Mail UI service
                             -------------------
    begin                : Thu Oct 31 15:55:16 EEST 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Eugen C. <eug@thekompany.com>
 ***************************************************************************/

#include <mailuipartprivate.h>
#include <kommailuiservice.h>
#include <komaetheratools.h>
#include <composerfactory.h>
#include <clientrmi.h>
#include <filter.h>
#include <mailfilter_plugin.h>
#include <mailimportservice.h>
#include <folderchooserdialog.h>

#include <qpopupmenu.h>
#include <qptrlist.h>
#include <qmainwindow.h>

MailUIPartPrivate::MailUIPartPrivate(UIPart* part)
  : KomUIPartPrivate(part)
{
}

MailUIPartPrivate::~MailUIPartPrivate()
{
}

void MailUIPartPrivate::slotNewMail()
{
  ComposerFactory::instance()->openComposer();
}

void MailUIPartPrivate::slot_settings()
{
  DEBUG_MSG("slot_settings");
  emit(showSettingsDialog());
}

  void
MailUIPartPrivate::slotCurrentURLChanged(const QString & url)
{
  static_cast<KomMailUIService *>(owner)->setCurrentURL(url);
}

void MailUIPartPrivate::slotSendReceive()
{
  ClientRMIModule *clientRMI = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
    if( ref.isValid() )
      clientRMI = static_cast<ClientRMIModule*>(ref.instance());
  }
  
  assert(0 != clientRMI);
  
  clientRMI->startSendReceive(clientRMI->getDefaultAccount());
//  clientRMI->startReceive(clientRMI->getDefaultAccount());
}

void MailUIPartPrivate::genSendReceiveMenus()
{
  KomMailUIService *ui = static_cast<KomMailUIService*> (owner);
  ClientRMIModule *clientRMI = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
    if( ref.isValid() )
      clientRMI = static_cast<ClientRMIModule*>(ref.instance());
  }
  
  assert(0 != clientRMI);
  
  accounts=clientRMI->getAccountNames();
  bool hasActiveAccounts=false;
  
  ui->toolsSendReceiveMenu->clear();
  ui->toolsSendMenu->clear();
  ui->toolsReceiveMenu->clear();

  for (unsigned int i = 0; i < accounts.count(); i++)
  {
    if (clientRMI->isAccountActive(accounts[i]))
    {
      hasActiveAccounts=true;
      ui->toolsSendReceiveMenu->insertItem(accounts[i], this, SLOT(startSendReceive(int)), 0, i+3);
      ui->toolsSendMenu->insertItem(accounts[i], this, SLOT(startSend(int)), 0, i+3);
      ui->toolsReceiveMenu->insertItem(accounts[i], this, SLOT(startReceive(int)), 0, i+3);
    }
  }
}

void MailUIPartPrivate::startSendReceive(int id)
{
  ClientRMIModule *clientRMI = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
    if( ref.isValid() )
      clientRMI = static_cast<ClientRMIModule*>(ref.instance());
  }
  
  assert(0 != clientRMI);

// TODO
//  sendReceiveDialog->start();

  if(!id)
  {
    for (unsigned int i = 0; i < accounts.count(); i++)
      if(clientRMI->isAccountActive(accounts[i]))
//        clientRMI->startReceive(accounts[i]);
        clientRMI->startSendReceive(accounts[i]);
  }
  else if(id==1)
  {
//    clientRMI->startReceive(clientRMI->getDefaultAccount());
    clientRMI->startSendReceive(clientRMI->getDefaultAccount());
  }
  else
  {
//    clientRMI->startReceive(accounts[id-3]);
    clientRMI->startSendReceive(accounts[id-3]);
  }
}

void MailUIPartPrivate::startSend(int id)
{
  ClientRMIModule *clientRMI = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
    if( ref.isValid() )
      clientRMI = static_cast<ClientRMIModule*>(ref.instance());
  }
  
  assert(0 != clientRMI);

// TODO
//  sendReceiveDialog->start();

  if (!id)
  {
    for (unsigned int i=0;i<accounts.count();i++)
      if(clientRMI->isAccountActive(accounts[i]))
        clientRMI->startSend(accounts[i]);
  }
  else if (id == 1)
  {
    clientRMI->startSend(clientRMI->getDefaultAccount());
  }
  else
  {
    clientRMI->startSend(accounts[id-3]);
  }
}

void MailUIPartPrivate::startReceive(int id)
{
  ClientRMIModule *clientRMI = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_RMI_CLIENT );
    if( ref.isValid() )
      clientRMI = static_cast<ClientRMIModule*>(ref.instance());
  }
  
  assert(0 != clientRMI);

// TODO
//  sendReceiveDialog->start();

  if (!id)
  {
    for (unsigned int i = 0; i < accounts.count(); i++)
      if(clientRMI->isAccountActive(accounts[i]))
        clientRMI->startReceive(accounts[i]);
  }
  else if(id==1)
  {
    clientRMI->startReceive(clientRMI->getDefaultAccount());
  }
  else
  {
    // debug
    qDebug("MainWindow: startReceive selected, account %s", (const char *)accounts[id-3]);

    clientRMI->startReceive(accounts[id-3]);
  }
}

void MailUIPartPrivate::slotImport()
{
  SAMport_Abstract record;
  
  MailImportService *mis = 0;
  VFSModule *vfs = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( MAILIMPORTSERVICE_SERVICE );
    if( ref.isValid() )
      mis = static_cast<MailImportService*>(ref.instance());
    ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
    if( ref.isValid() )
      vfs = static_cast<VFSModule*>(ref.instance());
  }
  
  assert(0 != vfs);
  
  // Configure the import parameters
  if( mis && mis->setup() )
  {
    // choose a folder where to import the emails
    QString targetPath = FolderChooserDialog::getFolder("/Mail", 0);
    if( targetPath.isEmpty() )
      return;
    
    // Browse the records from 'first' until 'next' is wrong
    record=mis->first();
    while( record.Num )
    {
      // make a new mail in Aethera
      QByteArray data;
      QDataStream dataStream(data, IO_WriteOnly);
      QCString rfc822=record.FullHeader.c_str();
      rfc822+="\r\n";
      rfc822+=record.FullMsg.c_str();

      qDebug("Import a new message.");
      
      dataStream << rfc822 << QCString(record.Message_Id.c_str())
                 << QDateTime::currentDateTime() << QString("default");
      vfs->createObject(targetPath, data);
      
      // go to the next record
      record=mis->next();
    }
    
    mis->close();
  }
}

void MailUIPartPrivate::slotFilters()
{
  MailFilterV *mailFilter = 0;
  ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
  if( trader )
  {
    ComponentRef ref = trader->registeredComponent( AETHERA_MAILFILTER_SERVICE );
    if( ref.isValid() )
      mailFilter = static_cast<MailFilterV*>(ref.instance());
  }
  
  if( !mailFilter )
    return;
  
  mailFilter->configure(0L,0L);
}

void MailUIPartPrivate::genWindowShowMenus()
{
  int i = 0;
  KomMailUIService *ui = static_cast<KomMailUIService*> (owner);
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );

  ui->windowShowMenu->clear();
    
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    ui->windowShowMenu->insertItem((*it)->caption(), this, SLOT(slotWindowShow(int)), 0, i);
    i++;
  }
}

void MailUIPartPrivate::genWindowHideMenus()
{
  int i = 0;
  KomMailUIService *ui = static_cast<KomMailUIService*> (owner);
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );
  
  ui->windowHideMenu->clear();
    
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    if( (*it)->isVisible() )
    {
      ui->windowHideMenu->insertItem((*it)->caption(), this, SLOT(slotWindowHide(int)), 0, i);
    }
    
    i++;
  }
}

void MailUIPartPrivate::genWindowCloseMenus()
{
  int i = 0;
  KomMailUIService *ui = static_cast<KomMailUIService*> (owner);
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );
  
  ui->windowCloseMenu->clear();
    
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    ui->windowCloseMenu->insertItem((*it)->caption(), this, SLOT(slotWindowClose(int)), 0, i);
    i++;
  }
}

void MailUIPartPrivate::slotWindowShow(int id)
{
  int i = 0;
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );
  
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    if( i == id )
    {
      (*it)->show();
      break;
    }
    i++;
  }
}

void MailUIPartPrivate::slotWindowHide(int id)
{
  int i = 0;
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );
  
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    if( i == id )
    {
      (*it)->hide();
      break;
    }
    i++;
  }
}

void MailUIPartPrivate::slotWindowClose(int id)
{
  int i = 0;
  QPtrList<QMainWindow> windows( ComposerFactory::instance()->windows() );
  
  for(QPtrListIterator<QMainWindow> it(windows); it.current(); ++it)
  {
    if( i == id )
    {
      (*it)->close();
      break;
    }
    i++;
  }
}

void MailUIPartPrivate::slotWindowCloseAll()
{
  ComposerFactory::instance()->clear();
}
