#ifndef POPUPACTION_H
#define POPUPACTION_H

#include <qaction.h>
#include <defines.h>

class QPopupMenu;
class QToolButton;

class MAIL_PLUGIN_API PopupAction : public QAction
{
  Q_OBJECT

  public:
  
    PopupAction(QWidget *parent, const char *name=0);
    PopupAction( const QString & text, const QIconSet & icon,
                 const QString & menuText, QKeySequence accel,
                 QObject * parent, const char * name = 0,
                 bool toggle = false);
    virtual ~PopupAction();
    
    virtual bool addTo(QWidget *);
    
    virtual void setPopup(QPopupMenu*);
    virtual QPopupMenu* popup() const;
  
  signals:
    void activated(int);
   
  protected slots:
    virtual void slotActivated(int);
  
  protected:
    virtual void addedTo(QWidget*, QWidget*);
    virtual void update(int);
  
    QPopupMenu * popupMenu;
};

#endif
