/*
    Copyright (C) 2001-2002 by theKompany.com <www.thekompany.com>
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    In addition, as a special exception, theKompany.com gives permission
    to link the code of this program with the tkwidgets library (or with
    modified versions of tkwidgets that use the same license as tkwidgets),
    and distribute linked combinations including the two.  You must obey
    the GNU General Public License in all respects for all of the code used
    other than tkwidgets.  If you modify this file, you may extend this
    exception to your version of the file, but you are not obligated to do so.
    If you do not wish to do so, delete this exception statement from your
    version.

    This license grants you the ability to use tkwidgets with Aethera only
    and may not be used outside of Aethera.
    See also http://www.thekompany.com/products/license.txt for details.
*/
/***************************************************************************
    komnotesmaintreeslots.h
                             -------------------
    begin                : Thu Nov  1 20:54:38 GMT 2001
    copyright            : (C) 2001 by theKompany.com
    author               : Rik Hemsley <rik@kde.org>
 ***************************************************************************/

#ifndef KOM_NOTES_MAIN_TREE_SLOTS_H
#define KOM_NOTES_MAIN_TREE_SLOTS_H

#include <qobject.h>
#include <defines.h>

class KomNotesMainTreeInterface;
class KomBackendService;

class NOTE_PLUGIN_API KomNotesMainTreeSlots : public QObject
{
  Q_OBJECT

  public:

    KomNotesMainTreeSlots(KomNotesMainTreeInterface * parent, const char * name);

    virtual ~KomNotesMainTreeSlots();

  public slots:

    void slotCreate(const QString &);

    void slotNewNote();
    void slotDeleteNote();
    void slotEditNote();
    void slotNewNoteGroup();
    void slotDeleteNoteGroup();
    void slotMoveNoteGroup();
    void slotRenameNoteGroup();
    void slotExpungeNoteGroup();

    void slotUpdateVInstances(const QStringList &);
    void slotCreateVInstances(const QStringList &);
    void slotDeleteVInstances(const QStringList &);
    void slotUpdateHierarchy(const QString &);

    void slotCreateVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type,
        const QString & subType,
        const QString & serverPath
      );

    void slotDeleteVFolder
      (
        const QString & parentFolderPath,
        const QString & folderName,
        const QString & type
      );

  private:

    KomNotesMainTreeInterface * m_mainTreeInterface;

    QString m_toBeEditedWhenCreated;
};


#endif
// vim:tabstop=2:shiftwidth=2:expandtab:cinoptions=(s,U1,m1
