//own includes
#include <vfsnotelist.h>

//komcontactplugin includes
#include <vfsnotelistview.h>
#include <vfsnoteiconview.h>
#include <vfsnotepreview.h>

/*
-------------------------------------------------
The widget
-------------------------------------------------
*/
VFSNoteList::VFSNoteList()
{
}


VFSNoteList::~VFSNoteList()
{

}

bool VFSNoteList::hasCapability(const QString& capa)
{
  if( capa==OBJECT_VIEW    ||
      capa==OBJECT_PREVIEW
    )
    return true;

  return false;
}


bool VFSNoteList::hasMultipleView()
{
  return true;
}


bool VFSNoteList::hasView(const ViewType& type)
{
  if( type==ListView || type==IconView )
    return true;

  return false;
}


VFSObjectIconView* VFSNoteList::newObjectIconView(QWidget* parent, const char* name)
{
  return new VFSNoteIconView(parent,name);
}


VFSObjectListView* VFSNoteList::newObjectView(QWidget* parent, const char* name)
{
  return new VFSNoteListView(parent,name);
}


VFSObjectPreview* VFSNoteList::newObjectPreview(QWidget* parent, const char* name)
{
  return new VFSNotePreview(parent,name);
}


/*
-------------------------------------------------
The widget factory
-------------------------------------------------
*/
kore::Interface* vfsnotelist_factory()
{
  return new VFSNoteListFactory();
}


VFSNoteListFactory::VFSNoteListFactory()
{
  MetaInfo* info = metaInfo();

  info->replaceAll("name","VFSNoteListFactory");
  info->replaceAll("class","VFSNoteListFactory");
  info->replaceAll("class/fqn","VFSNoteListFactory");
  info->replaceAll("factory","vfsnotelist_factory");
  info->replaceAll("description",AETHERA_VFS_NOTE_LIST_FACTORY_DESC);
  info->replaceAll("service", AETHERA_VFS_NOTE_LIST_FACTORY);
}


VFSNoteListFactory::~VFSNoteListFactory()
{
  
}


VFSObjectList* VFSNoteListFactory::newObjectList()
{
  VFSNoteList* noteList = new VFSNoteList();

  if( noteList )
    return noteList;

  return 0L;
}

