//own includes
#include <vfsnotepreview.h>

//komnotesplugin includes
#include <vnoteobject.h>

//Aethera includes
#include <vfsmodule.h> 
#include <vfolder.h>

//QT includes
#include <qtextbrowser.h>
#include <qregexp.h>
#include <qlayout.h>

VFSNotePreview::VFSNotePreview(QWidget* parent, const char* name)
  :VFSObjectPreview( parent, name ),
   vfs( 0L ),
   notePreview( 0L ),
   automaticPreviewCheckbox(0L),
   generatePreviewButton(0L)
{
  QHBoxLayout* widgetLayout = new QHBoxLayout( this, 0, 3, "widgetLayout" );

  if(!notePreview)
    notePreview = new QTextBrowser( this, "notePreview");

  if(notePreview)
  {
    notePreview->setTextFormat(Qt::RichText);
    widgetLayout->addWidget( notePreview );
  }

  QVBoxLayout* previewControlLayout = new QVBoxLayout( this, 0, 3, "previewControlLayout" );
  QSpacerItem* topSpace = new QSpacerItem( 100,20 );
  previewControlLayout->addItem( topSpace );
  if(!automaticPreviewCheckbox)
  {
    automaticPreviewCheckbox = new QCheckBox( "Automatic",
                                              this,
                                              "automaticPreviewCheckbox"
                                            );
    automaticPreviewCheckbox->setChecked( true );
    previewControlLayout->addWidget( automaticPreviewCheckbox );
  }

/*
We will add this feature as soon as posible
*/

//  if(!generatePreviewButton)
//  {
//    generatePreviewButton = new QPushButton( "Preview", this, "generatePreviewButton" );
//    previewControlLayout->addWidget( generatePreviewButton );
//  }
  widgetLayout->addLayout( previewControlLayout );
    
  if(!vfs)
  {
    ComponentTrader* trader = dynamic_cast<ComponentTrader*>(ComponentTrader::traderRef().instance());
    if( trader )
    {
      ComponentRef ref = trader->registeredComponent( AETHERA_VFS_SERVICE );
      if( ref.isValid() )
          vfs = static_cast<VFSModule*>(ref.instance());
    }
  }
  
}


VFSNotePreview::~VFSNotePreview()
{
  delete notePreview;
  notePreview=0L;
}


void VFSNotePreview::slotSetObject(const QString& path)
{
  VNoteObject* selectedNote=0L;

  if(vfs)
    selectedNote = reinterpret_cast<VNoteObject*>( vfs->objectRef(path) );

  if( selectedNote )
  {
    bool renderPreview = automaticPreviewCheckbox->isChecked();
    if( renderPreview )
    {
      notePreview->setPaper( QBrush(selectedNote->color()) );
      QString noteText;
      QString noteTitle=selectedNote->text();

      noteTitle.replace(QRegExp("\n"), " ");
      noteTitle.truncate(20);
      noteTitle+="...";

      noteText+="<qt>";
        noteText+="<table cols=\"2\" width=\"95%\">";
          noteText+="<tr>";
            noteText+="<td bgcolor=\"3C3FA7\"><font size=\"5\" color=\"#FFFFFF\"><strong>Note:</strong></font></td>";
            noteText+="<td bgcolor=\"7C7FA7\"><font size=\"5\" color=\"#FFFFFF\"><strong>";
              noteText+=noteTitle;
            noteText+="</strong></font></td>";
          noteText+="</tr>";
        noteText+="</table>";
        noteText+=selectedNote->text();
      noteText+="</qt>";
      
      notePreview->setText( noteText );
    }
    else
    {
      notePreview->setText( "" );
    }
  }
}


void VFSNotePreview::slotToggleVisibility(bool visibility)
{
  if(!visibility)
  {
    hide();
  }
  else
  {
    show();
  }
}
