/***************************************************************************
                          imap4updatemessagejob.cpp  -  description
                             -------------------
    begin                : Tue Jun 18 2002
    copyright            : (C) 2002 by theKompany.com
    email                : eug@thekompany.com
 ***************************************************************************/

#include "imap4updatemessagejob.h"

#include <imap4client.h>
#include <imap4handler.h>
#include <commandsprocessor.h>
#include <messagedevice.h>

#include <appstatus.h>

IMAP4UpdateMessageJob::IMAP4UpdateMessageJob
(
  QSocket           * sock,
  IMAP4Client       * parent
)
  : IMAP4Job(sock, parent),
    state_( START )
{
  // Empty.
}

IMAP4UpdateMessageJob::~IMAP4UpdateMessageJob()
{
  // Empty.
}

  void
IMAP4UpdateMessageJob::run()
{
#ifdef IMAP4_DEBUG
  qDebug("IMAP4UpdateMessageJob::run %s", command()->parameters.latin1());
#endif
    
  status->message(AppStatus::Server, AppStatus::Text, AppStatus::Waiting,
    "Downloading the message...");
  
  state_ = WaitingForUidFetch;
  client()->sendUid( QString("FETCH ") + command()->parameters + " (FLAGS INTERNALDATE UID BODY[])");  
}

  bool
IMAP4UpdateMessageJob::processLine(const QString & line)
{
  QString firstWord;
  
  client()->parseNextWord(firstWord, line);
  if( firstWord == client()->getTag() )
  {
    if( client()->replyOK(line) )
    {
      switch( state_ )
      {
        case WaitingForUidFetch:
          state_ = DONE;
          emit finished(true);
          break;
        default:
          qDebug("IMAP4DeleteFolderJob::processLine() : wrong state");
          emit finished(false);
          return false;
          break;
      }
      
      return true;
    }
    else
    {
      qDebug("IMAP4UpdateMessageJob::processLine() : bad answer : %s", line.latin1());
      
      emit finished(false);
      
      return false;
    }
  }
  else
    return client()->parseLine(line);
    
  emit finished(false);
  return false;
}

  bool
IMAP4UpdateMessageJob::processMultiLine(const QByteArray & block)
{
#ifdef IMAP4_DEBUG
  qDebug("IMAP4UpdateMessageJob::processMultiLine");
#endif
  
  return client()->handleFetchData(block);
}

