
/***************************************************************************
    begin                : Fri Jan 18 21:42:04 EET 2002
    copyright            : (C) 2002 by theKompany.com
    author               : Iulian Ghiciuc
 ***************************************************************************/

#ifndef KOM_EVENT_ALARM_SERVICE
#define KOM_EVENT_ALARM_SERVICE

//own includes
#include "komeventalarmhandler.h"

//Aethera includes
#include <komaetheraplugin.h>
#include <komeventalarmhandler.h>
#include <appstatus.h>
#include <vfsmodule.h>

//QT includes
#include <qtimer.h>

extern "C"
{
    DATEBOOK_PLUGIN_API kore::Interface* komeventalarmservice_factory();
};

class KomEventAlarmService : public KomAetheraService
{
  public:
    KomEventAlarmService();
    ~KomEventAlarmService();

    void start();
    void stop();
    void slotCheckEvents();
    void slotUseAlarm(bool);
    bool isOn() { return useAlarm; }

  private:
    void checkCalendars( const QString& path );
    void saveSettings();
    QDateTime currentLocalTime();
    
    KomEventAlarmHandler* qtHandler;
    VFSModule* vfs;
    AppStatus* status;
    QTimer* timer;
    unsigned int interval;
    bool hasEvents;
    bool useAlarm;
};

#endif //KOM_EVENT_ALARM_SERVICE

