include(../defines.pri)

TEMPLATE  = lib
CONFIG  += dll

# DEFINES += KORG_NODND KORG_NOPLUGINS KORG_NOKABC KORG_NOARCHIVE KORG_NOMAIL
# DEFINES += KORG_NOPRINTER KORG_NOSPLITTER KORG_NORECURRENCE KORG_NODCOP

DEFINES += KORG_NOPLUGINS KORG_NOKAB KORG_NOKABC KORG_NOARCHIVE KORG_NOMAIL KORG_NODCOP KORG_NOLVALTERNATION

win32 {
TARGET    = libkorganizer
}

unix {
TARGET    = korganizer
}

HEADERS += \
  archivedialog.h \
  baseview.h \
  calendarlistview.h \
  calendarlistviewitem.h \
  calendarmainview.h \
  calendarobject.h \
  calendarobjectview.h \
  calendarview.h \
  calendarviewbase.h \
  calprinter.h \
  categoryeditdialog.h \
  categoryselectdialog.h \
  customlistviewitem.h \
  datenavigator.h \
  docprefs.h \
  filtereditdialog.h \
  hconv.h \
  incomingdialog.h \
  journalentry.h \
  kcalendarsystem.h \
  kcalendarsystemhijri.h \
  kdatenavigator.h \
  koagenda.h \
  koagendaitem.h \
  koagendaview.h \
  kocounterdialog.h \
  kodaymatrix.h \
  kodialogmanager.h \
  koeditordetails.h \
  koeditorgeneralevent.h \
  koeditorgeneral.h \
  koeditorgeneraltodo.h \
  koeditorrecurrence.h \
  koeventeditor.h \
  koeventpopupmenu.h \
  koeventviewerdialog.h \
  koeventviewer.h \
  koeventview.h \
  kofilterview.h \
  koglobals.h \
  koincidenceeditor.h \
  kojournalview.h \
  kolistview.h \
  komkobackendservice.h \
  komkoplugin.h \
  komkotreeinterface.h \
  komkotreeitem.h \
  komkotreeslots.h \
  komkouiservice.h \
  komonthview.h \
  koprefsdialog.h \
  koprefs.h \
  kotimespanview.h \
  kotodoeditor.h \
  kotodoview.h \
  kotodoviewitem.h \
  kouipartprivate.h \
  koviewmanager.h \
  kowhatsnextview.h \
  kpimprefs.h \
  kprefs.h \
  kprefsdialog.h \
  ktimeedit.h \
  lineview.h \
  outgoingdialog.h \
  publishdialog.h \
  savetemplatedialog.h \
  searchdialog.h \
  statusdialog.h \
  timeline.h \
  timespanview.h \
  version.h\
  komeventalarmservice.h\
  komeventalarmhandler.h

SOURCES += \
  archivedialog.cpp \
  calendarlistview.cpp \
  calendarlistviewitem.cpp \
  calendarmainview.cpp \
  calendarobject.cpp \
  calendarobjectview.cpp \
  calendarview.cpp \
  calprinter.cpp \
  categoryeditdialog.cpp \
  categoryselectdialog.cpp \
  datenavigator.cpp \
  docprefs.cpp \
  filtereditdialog.cpp \
  hconv.c \
  incomingdialog.cpp \
  journalentry.cpp \
  kdatenavigator.cpp \
  koagenda.cpp \
  koagendaitem.cpp \
  koagendaview.cpp \
  kcalendarsystem.cpp \
  kcalendarsystemhijri.cpp \
  kocounterdialog.cpp \
  kodaymatrix.cpp \
  kodialogmanager.cpp \
  koeditordetails.cpp \
  koeditorgeneral.cpp \
  koeditorgeneralevent.cpp \
  koeditorgeneraltodo.cpp \
  koeditorrecurrence.cpp \
  koeventeditor.cpp \
  koeventpopupmenu.cpp \
  koeventview.cpp \
  koeventviewer.cpp \
  koeventviewerdialog.cpp \
  kofilterview.cpp \
  koglobals.cpp \
  koincidenceeditor.cpp \
  kojournalview.cpp \
  kolistview.cpp \
  komkobackendservice.cpp \
  komkoplugin.cpp \
  komkotreeinterface.cpp \
  komkotreeitem.cpp \
  komkotreeslots.cpp \
  komkouiservice.cpp \
  komonthview.cpp \
  koprefs.cpp \
  koprefsdialog.cpp \
  kotimespanview.cpp \
  kotodoeditor.cpp \
  kotodoview.cpp \
  kotodoviewitem.cpp \
  kouipartprivate.cpp \
  koviewmanager.cpp \
  kowhatsnextview.cpp \
  kpimprefs.cpp \
  kprefs.cpp \
  kprefsdialog.cpp \
  ktimeedit.cpp \
  lineview.cpp \
  outgoingdialog.cpp \
  publishdialog.cpp \
  savetemplatedialog.cpp \
  searchdialog.cpp \
  statusdialog.cpp \
  timeline.cpp \
  timespanview.cpp\
  komeventalarmservice.cpp\
  komeventalarmhandler.cpp

INTERFACES += \
  categoryeditdialog_base.ui \
  categoryselectdialog_base.ui \
  filteredit_base.ui \
  help.ui \
  incomingdialog_base.ui \
  kofilterview_base.ui \
  outgoingdialog_base.ui \
  publishdialog_base.ui

INCLUDEPATH += .
DEPENDPATH += .
INCLUDEPATH += ..
DEPENDPATH += ..
INCLUDEPATH += ../libical/src/libical
DEPENDPATH += ../libical/src/libical
INCLUDEPATH += ../libical/src/libicalss
DEPENDPATH += ../libical/src/libicalss
INCLUDEPATH += ../minikde
DEPENDPATH += ../minikde
INCLUDEPATH += ../libkcal
DEPENDPATH += ../libkcal
INCLUDEPATH += /usr/local/include/tkcbase
DEPENDPATH += /usr/local/include/tkcbase
INCLUDEPATH += /usr/local/include/kore
DEPENDPATH += /usr/local/include/kore
INCLUDEPATH += /usr/local/include/tino
DEPENDPATH += /usr/local/include/tino
INCLUDEPATH += /usr/local/include/tkwidgets
DEPENDPATH += /usr/local/include/tkwidgets
INCLUDEPATH += /usr/local/include/aethera
DEPENDPATH += /usr/local/include/aethera

win32 {
LIBS  += ../libical/src/libical/ical.lib
LIBS  += ../libical/src/libicalss/icalss.lib
LIBS  += ../minikde/minikde.lib
LIBS  += ../libkcal/kcal.lib 
LIBS  += aethera.lib tino.lib
LIBS  += tkcbase.lib tkcssl.lib libkore.lib tkwidgets.lib
}

unix {
LIBS += -L../libkcal -lkcal -L../minikde -lminikde 
LIBS += ../libical/src/libical/libical.a
LIBS += ../libical/src/libicalss/libicalss.a

LIBS += -L$$AETHERA_LIB -laethera

icons1.path      = $$AETHERA_DIR/pics/
icons1.files     = ./pixmaps/*.*
INSTALLS       += icons1

icons2.path      = $$AETHERA_DIR/pics/
icons2.files     = ../pics/*.*
INSTALLS       += icons2

plugin.path     = $$AETHERA_DIR/plugins/
plugin.files    = lib*.so.1.0.0
INSTALLS       += plugin

  plugin.extra = \
  cd $$AETHERA_DIR/plugins; \
  rm -f libkorganizer.so.1.0; \
  ln -s libkorganizer.so.1.0.0 \
        libkorganizer.so.1.0; \
  rm -f libkorganizer.so.1; \
  ln -s libkorganizer.so.1.0 \
        libkorganizer.so.1; \
  rm -f libkorganizer.so; \
  ln -s libkorganizer.so.1 \
        libkorganizer.so
}

