
#include "settings.h"

Settings *Settings::instance_=0;

#ifdef _QTE_
Settings::Settings()
  : Config(AppName),
    name_ (QString("/") + AppName)
{
}
#else
Settings::Settings()
  : QSettings(),
    name_ (QString("/") + AppName)
{
#ifdef _QTWIN_
  setPath(QString::null, QString::null, QSettings::User);
#endif
}
#endif

Settings::~Settings()
{
}

Settings * Settings::instance()
{
  if( !instance_ )
    instance_ = new Settings;
  
  return instance_;
}

void Settings::forceWrite()
{
  // Deletion should be fine, as instance() will create a new one.
  delete instance_;
  instance_ = 0;
}

const QString & Settings::name()
{
  return name_;
}

